<!--
    Usage: 
        - Options: if you want to change the default options start the Question with: {[key:param;]}
            - The different options can be used together and mixed as needed. 
            - For example to change the number of Answers revealed before the current Field enter:
                {[v:0.1;prev:2]}
            - To show three answers before the current question, and two afterwards use:
                {[v:0.1;prev:3;next:2]}
            - To additionally show the currently used options use:
                {[v:0.1;prev:3;next:2;showOptions:0]}
            - If you want to show the hints rather than a blank on the other fields use:
                {[v:0.1;showHintOnOthers:1]}
            - Allowed Values:
                - v: The version number this question is made for. It is recommended to add this value
                    to every question to allow backwards compatability. 
                    Allowed Values: 
                        - 0.1
                            [default value] current version
                - prev: Number of fields that are revealed before the current field to provide context
                    Allowed Values:
                        - positive integer
                        - 1 
                            [default value]
                - next: Number of fields that are revealed after the current field to provide context
                    Allowed Values:
                        - positive integer
                        - 0 
                            [default value]
                - showHintOnOthers: toggles whether hints or blanks are shown on the other non-context
                    fields.
                    Allowed Values:
                        - 0
                            show blank
                        - 1 
                            [default value] show hint
                - showOptions: toggles whether the options are displayed at the beginning of the 
                    question.
                    Allowed Values:
                        - 0
                            [default value] don't show options
                        - 1 
                            show options
        - Field:
            - Example:
                {c1::[[Answer1|c2;c3]]::Hint1}
                This creates one card with the answer "Answer1" which reveals for context c2 and c3 
                and has the hint "Hint1"
-->

<div id="md_content"></div>
<div id="debug"></div>

<script>
runthisapp()
function runthisapp() {
    let options = {v: '0.1', prev: 1, next: 0, showHintOnOthers: 0, showOptions: 0, debug: 0}

    main(options)

    function print(text) {
        const d = document.getElementById('debug')
        if(!options.debug) {
            return
        }
        d.innerHTML += '<br />' + text
    }

    function printObject(obj) {
        print(JSON.stringify(obj))
    }

    function loopPrintObject(obj) {
        for(key in obj) {
            print(key + ": " + obj[key])
        }
    }

    function main(options) {
        options = getOptions(options)
        const version = getFunctionForVersion(options)
        version(options)
    }

    function getFunctionForVersion(options) {
        if(options.v === "0.1") {
            return main0_1
        }
        return main0_1
    }

    function getOptions(options) {
		const intParams = ["prev", "next", "showHintOnOthers", "showOptions", "debug"]
        const clozeText = `{{cloze:Text}}`
        const re = /(?<=\{\[).*?(?=\]\})/gm
        const match = Array.from(clozeText.matchAll(re))
		if(match.length === 0) {
			return options
		}
        const nameAndParameter = match[0][0].split(";")
        for(let i = 0; i < nameAndParameter.length; i++) {
			if(nameAndParameter[i].length < 1) {
				continue
			}
            const nameAndParameterArray = nameAndParameter[i].split(":")
            const name = nameAndParameterArray[0]
            const parameter = nameAndParameterArray[1]
			if(intParams.some(k => k === name)) {
				options[name] = parseInt(parameter)
			} else {
            		options[name] = parameter
			}
        }
        return options
    }

    function main0_1(options) {
        const md_content = document.getElementById('md_content')
        const data = getDataSet()
        const display = getDisplay(data)
        md_content.innerHTML = display

        function getDisplay(data) {
            let display = displayOptions(options)
            for(let i = 0; i < data.answers.length; i++) {
                display += getSection(data, i)
            }
            return display
        }

        function displayOptions(options) {
            if(options.showOptions === 1) {
                return JSON.stringify(options)
            } else {
                return ''
            }
        }

        function getSection(data, id) {
            let display = ''
            const answer = data.answers[id]
            display += answer.pre
            display += getAnswerDisplay(data, id)
            display += answer.post
            return display
        }

        function getAnswerDisplay(data, id) {
            let display = ''
            const answer = data.answers[id]
            if(isCurrentQuestion(data, id)) {
                display = mkCurrentQuestion(data, id)
            } else if(isContextOfCurrentQuestion(data, id)) {
                display = mkContextOfCurrentQuestion(data, id)
            } else if(currentQuestionHasNoContext(data, id) && isPreviousOrNext(data, id)) {
                display = mkContextOfCurrentQuestion(data, id)
            } else {
                display = mkHidden(data, id)
            }
            return display
        }

        function isPreviousOrNext(data, id) {
            for(i of data.currentAnswers) {
                if(i - id <= options.prev && i - id > 0) {
                    return true
                }
                if(id - i <= options.next && id -i > 0) {
                    return true
                }
            }
            return false
        }

        function mkHidden(data, id) {
            if(options.showHintOnOthers === 1 && questionHasHint(data, id)) {
                return mkFieldWithHint(data, id, 'black')
            } else {
                return mkFieldWithCover(data, id, 'black', 'black-hidden')
            }
        }

        function currentQuestionHasNoContext(data, id) {
            for(i of data.currentAnswers) {
                if(data.answers[i].context.length > 0) {
                    return false
                }
            }
            return true
        }

        function mkContextOfCurrentQuestion(data, id) {
            return mkNormalField(data, id, 'black')
        }

        function mkNormalField(data, id, baseClass) {
            return `<span class='${baseClass}'>${data.answers[id].answer}</span>`
        }

        function isContextOfCurrentQuestion(data, id) {
            for(i of data.currentAnswers) {
                if(data.answers[i].context.includes(id)) {
                    return true
                }
            }
            return false
        }

        function isCurrentQuestion(data, id) {
            return data.currentAnswers.includes(id)
        }

        function mkFieldWithHint(data, id, baseClass) {
            return `<div class='field'><span id='md_answer${id}' class='${baseClass}' onselectstart='return false'`
                + `onclick='document.getElementById("md_answer${id}").style.display = "none"; `
                + `document.getElementById("hint${id}").style.display = ""'; `
                + `style='display:none;'>${data.answers[id].answer}</span>`
                + `<div id='hint${id}' class='${baseClass}' onselectstart='return false'`
                + `onclick='document.getElementById("md_answer${id}").style.display = ""; `
                + `document.getElementById("hint${id}").style.display = "none"'; `
                + `style=''>[${data.answers[id].hint}]</div></div>`
        }

        function mkFieldWithCover(data, id, baseClass, coverClass) {
            return `<div id='md_container${id}' class='${baseClass} ${coverClass}' `
                + `onclick='${toggleHiding(id, coverClass)}'> `
                + `<span id='md_answer${id}' class='${baseClass}' onselectstart='return false' `
                + `style='visibility:hidden;'>${data.answers[id].answer}</span></div>`
        }

        function toggleHiding(id, coverClass) {
            return `const container = document.getElementById("md_container${id}")
            const answer = document.getElementById("md_answer${id}")
            if(answer.style.visibility === "visible") {
                answer.style.visibility = "hidden"
                container.classList.add("${coverClass}")
            } else {
                answer.style.visibility = "visible"
                container.classList.remove("${coverClass}")
            }`
        }

        function mkCurrentQuestion(data, id) {
            if(data.isFront) {
                if(questionHasHint(data, id)) {
                    return mkFieldWithHint(data, id, 'cloze')
                } else {
                    return mkFieldWithCover(data, id, 'cloze', 'coverClass')
                }
            } else {
                return mkNormalField(data, id, 'cloze')
            }
        }

        function questionHasHint(data, id) {
             return data.answers[id].hint !== undefined && data.answers[id].hint !== ""
        }

        /* This function returns the following dictionary:
        {
            isFront: true|false,
            currentAnswers: [integer, integer, ...],
            answers: [
                {
                    pre: "TEXT",
                    answer: "TEXT",
                    post: "TEXT",
                    hint: "TEXT",
                    id: "TEXT",
                    context: [integer, integer, ...],
                }, ...
            ]
        }
        */
        function getDataSet() {
            let data = {}
            const clozeTextData = parseClozeText()
            //printObject(clozeTextData)
            const textData = parseText()
            //printObject(textData[0].match.groups)
            data.currentAnswers = getCurrentAnswer(clozeTextData)
            data = addSimpleData(textData, data)
            data = convertContextString(data)
            data = addPostString(data, textData)
            data.isFront = thisIsTheFront(data, clozeTextData)
            printObject(data)
            return data
        }

        function thisIsTheFront(data, clozeTextData) {
            const answerId = data.currentAnswers[0]
            const correctAnswer = data.answers[answerId].answer
            const correctHint = data.answers[answerId].hint
            const currentDisplay = clozeTextData[answerId].match.groups.cur
            //print(correctAnswer)
            //print(correctHint)
            //print(currentDisplay)
            if(correctHint === currentDisplay) {
                return true
            } else if('...' === currentDisplay) {
                return true
            }
            return false
        }

        function addPostString(data, textData) {
            const text = `{{Text}}`
            data.answers[data.answers.length-1].post = text.substring(textData[textData.length - 1].index)
            return data
        }

        function addSimpleData(textData, data) {
            data.answers = []
            for(let i = 0; i < textData.length; i++) {
                data.answers[i] = {}
                const pre = textData[i].match.groups.pre
                data.answers[i].pre = i===0 ? removeOptionsString(pre) : pre
                answerAndContext = splitAnswer(textData[i].match.groups.answer)
                data.answers[i].answer = answerAndContext.answer
                data.answers[i].post = ''
                data.answers[i].hint = textData[i].match.groups.hint
                data.answers[i].id = textData[i].match.groups.id
                data.answers[i].contextString = answerAndContext.context
            }
            return data
        }

        function removeOptionsString(text) {
            const reg = /\{\[.*?\]\}/gm
            return text.replace(reg, '')
        }

        function convertContextString(data) {
            for(let i = 0; i < data.answers.length; i++) {
                data.answers[i].context = []
                for(let j = 0; j < data.answers[i].contextString.length; j++) {
                    let id = data.answers[i].contextString[j]
                    data.answers[i].context = data.answers[i].context.concat(getContextIds(data, id))
                }
            }
            return data
        }

        function getContextIds(data, id) {
            let ids = []
            for(let i = 0; i < data.answers.length; i++) {
                if(id === data.answers[i].id) {
                    ids.push(i)
                }
            }
            return ids
        }

        function splitAnswer(answer) {
            result = {}
            parts = answer.split('|')
            result.answer = parts[0]
            result.context = []
            if(parts[1]) {
                context = parts[1].split(';')
                for(c of context) {
                    if(c !== '') {
                        result.context.push(c)
                    }
                }
            }
            return result
        }

        function getCurrentAnswer(clozeTextData) {
            let currentAnswers = []
            for(let i = 0; i < clozeTextData.length; i++) {
                if(clozeTextData[i].match.groups.cur) {
                    currentAnswers.push(i)
                }
            }
            return currentAnswers
        }

        function parseText() {
            re = /(?<pre>.*?){\{(?<id>c\d+)::\[\[(?<answer>.*?)\]\](?:::(?<hint>.*?))?\}\}/gm
            const text = `{{Text}}`
            return getAllRegex(text, re)
        }

        /* Returns:
        {"q":"Answer1|c1"}
        {"q":"Answer2|c2"}
        {"q":"Answer3"}
        {"cur":"Hint4"}
        */
        function parseClozeText() {
            re = /(?<q>(?<=\[\[).*?(?=\]\]))|(?<cur>(?<=<span class=cloze>\[).*?(?=\]<\/span>))/gm
            const clozeText = `{{cloze:Text}}`
            return getAllRegex(clozeText, re)
        }

        function getAllRegex(text, re) {
            let res = []
            let match
            do {
                match = re.exec(text)
                if(match) {
                    res.push({"match": match, "index": re.lastIndex})
                }
            } while(match)
            return res
        }

        function htmlEncode ( html )
        {
            html = $.trim(html);
            return html.replace(/[&"'\<\>]/g, function(c) 
            {
                switch (c) 
                {
                    case "&":
                        return "&amp;";
                    case "'":
                        return "&#39;";
                    case '"':
                        return "&quot;";
                    case "<":
                        return "&lt;";
                    default:
                        return "&gt;";
                }
            });
        };

    }
}
</script>